searchData={"items":[{"type":"module","doc":"JavaScript interop.","title":"Hologram.JS","ref":"Hologram.JS.html"},{"type":"function","doc":"Executes JavaScript code.\nServer-side implementation is just a dummy. The actual implementation is on the client-side.","title":"Hologram.JS.exec/1","ref":"Hologram.JS.html#exec/1"},{"type":"function","doc":"Provides a convenient syntax for executing JavaScript code using the ~JS sigil.","title":"Hologram.JS.sigil_JS/2","ref":"Hologram.JS.html#sigil_JS/2"},{"type":"task","doc":"Builds Hologram project JavaScript bundles, the call graph of the code,\nPLTs needed by the runtime and PLTs needed to speed up future compilation.","title":"mix compile.hologram","ref":"Mix.Tasks.Compile.Hologram.html"},{"type":"function","doc":"Benchmarks: https://github.com/bartblast/hologram/blob/master/benchmarks/mix/tasks/compile.hologram/README.md","title":"Mix.Tasks.Compile.Hologram.run/1","ref":"Mix.Tasks.Compile.Hologram.html#run/1"},{"type":"task","doc":"Prints the list of automatically transpiled Elixir MFAs used by the Hologram client runtime\n(manually ported Elixir MFAs are excluded).","title":"mix holo.compiler.ex_runtime_mfas","ref":"Mix.Tasks.Holo.Compiler.ExRuntimeMfas.html"},{"type":"task","doc":"Calculates the JavaScript size of each Elixir function that is included in the specified page module bundle.\nThe results are sorted by size.","title":"mix holo.compiler.page_ex_fun_sizes","ref":"Mix.Tasks.Holo.Compiler.PageExFunSizes.html"},{"type":"task","doc":"$ mix holo.compiler.page_ex_fun_sizes MyPageModule \n\nWhere `MyPageModule` is the name of the page module you want to analyze (without the `Elixir.` prefix).","title":"Examples - mix holo.compiler.page_ex_fun_sizes","ref":"Mix.Tasks.Holo.Compiler.PageExFunSizes.html#module-examples"},{"type":"task","doc":"Prints paths from page entry MFAs to the given destination MFA.","title":"mix holo.compiler.page_to_mfa_paths","ref":"Mix.Tasks.Holo.Compiler.PageToMfaPaths.html"},{"type":"task","doc":"Prints paths from runtime entry MFAs to the given destination MFA.","title":"mix holo.compiler.runtime_to_mfa_paths","ref":"Mix.Tasks.Holo.Compiler.RuntimeToMfaPaths.html"},{"type":"task","doc":"Prints the list of page routes, ordered by route path.","title":"mix holo.routes","ref":"Mix.Tasks.Holo.Routes.html"},{"type":"task","doc":"Checks if any test scripts have invalid file names.\nFile name is valid if it ends with \"_test\" suffix and has \".exs\" extension.\nIf there are any invalid file names, the task exits with code 1.\nSupport dir and text_helper.exs file are ignored.\n\nScripts not adhering to the aforementioned rules wouldn't be picked up by the mix test task.","title":"mix holo.test.check_file_names","ref":"Mix.Tasks.Holo.Test.CheckFileNames.html"},{"type":"task","doc":"$ mix holo.test.check_file_names test/elixir","title":"Examples - mix holo.test.check_file_names","ref":"Mix.Tasks.Holo.Test.CheckFileNames.html#module-examples"},{"type":"module","doc":"","title":"Hologram","ref":"Hologram.html"},{"type":"function","doc":"Returns the current environment.","title":"Hologram.env/0","ref":"Hologram.html#env/0"},{"type":"behaviour","doc":"","title":"Hologram.Component","ref":"Hologram.Component.html"},{"type":"function","doc":"Resolves the colocated template path for the given component module given its file path.","title":"Hologram.Component.colocated_template_path/1","ref":"Hologram.Component.html#colocated_template_path/1"},{"type":"callback","doc":"Initializes component and server structs (when run on the server).","title":"Hologram.Component.init/3","ref":"Hologram.Component.html#c:init/3"},{"type":"function","doc":"Returns the AST of template/0 function definition that uses markup fetched from the give template file.\nIf the given template file doesn't exist nil is returned.","title":"Hologram.Component.maybe_define_template_fun/2","ref":"Hologram.Component.html#maybe_define_template_fun/2"},{"type":"macro","doc":"Accumulates the given property definition in __props__ module attribute.","title":"Hologram.Component.prop/3","ref":"Hologram.Component.html#prop/3"},{"type":"function","doc":"Puts the given action spec to the component or server struct's next_action field.\nNext action will be executed by the runtime synchronously.","title":"Hologram.Component.put_action/2","ref":"Hologram.Component.html#put_action/2"},{"type":"function","doc":"Puts the given action spec to the component or server struct's next_action field.\nNext action will be executed by the runtime synchronously.","title":"Hologram.Component.put_action/3","ref":"Hologram.Component.html#put_action/3"},{"type":"function","doc":"Puts the given command spec to the component's next_command field.\nNext command will be sent asynchronously to the server.","title":"Hologram.Component.put_command/2","ref":"Hologram.Component.html#put_command/2"},{"type":"function","doc":"Puts the given command spec to the component's next_command field.\nNext command will be sent asynchronously to the server.","title":"Hologram.Component.put_command/3","ref":"Hologram.Component.html#put_command/3"},{"type":"function","doc":"Puts the given key-value pair to the component's emitted_context field.\nContext emitted by a component is available to all of its child nodes.","title":"Hologram.Component.put_context/3","ref":"Hologram.Component.html#put_context/3"},{"type":"function","doc":"Puts the given page module to the component's next_page field.\nThe client will navigate to this page asynchronously after the current action finished executing.","title":"Hologram.Component.put_page/2","ref":"Hologram.Component.html#put_page/2"},{"type":"function","doc":"Puts the given page module and params to the component's next_page field (as a tuple).\nThe client will navigate to this page asynchronously after the current action finished executing.","title":"Hologram.Component.put_page/3","ref":"Hologram.Component.html#put_page/3"},{"type":"function","doc":"Puts the given key-value entries to the component state.","title":"Hologram.Component.put_state/2","ref":"Hologram.Component.html#put_state/2"},{"type":"function","doc":"If the second arg is a list of keys representing a component state path\nit puts the value in the nested component state path,\notherwise it puts the given key-value pair to the component state.","title":"Hologram.Component.put_state/3","ref":"Hologram.Component.html#put_state/3"},{"type":"function","doc":"Returns the AST of code that registers __props__ module attribute.","title":"Hologram.Component.register_props_accumulator/0","ref":"Hologram.Component.html#register_props_accumulator/0"},{"type":"type","doc":"","title":"Hologram.Component.t/0","ref":"Hologram.Component.html#t:t/0"},{"type":"callback","doc":"Returns a template in the form of an anonymous function that given variable bindings returns a DOM.","title":"Hologram.Component.template/0","ref":"Hologram.Component.html#c:template/0"},{"type":"module","doc":"","title":"Hologram.Component.Action","ref":"Hologram.Component.Action.html"},{"type":"type","doc":"","title":"Hologram.Component.Action.t/0","ref":"Hologram.Component.Action.html#t:t/0"},{"type":"module","doc":"","title":"Hologram.Component.Command","ref":"Hologram.Component.Command.html"},{"type":"type","doc":"","title":"Hologram.Component.Command.t/0","ref":"Hologram.Component.Command.html#t:t/0"},{"type":"behaviour","doc":"","title":"Hologram.Page","ref":"Hologram.Page.html"},{"type":"function","doc":"Casts page params string values to types specified with param/2 macro.","title":"Hologram.Page.cast_params/2","ref":"Hologram.Page.html#cast_params/2"},{"type":"callback","doc":"Initializes component and server structs (when run on the server).","title":"Hologram.Page.init/3","ref":"Hologram.Page.html#c:init/3"},{"type":"macro","doc":"Defines page's layout metadata functions.","title":"Hologram.Page.layout/2","ref":"Hologram.Page.html#layout/2"},{"type":"macro","doc":"Accumulates the given param definition in __params__ module attribute.","title":"Hologram.Page.param/3","ref":"Hologram.Page.html#param/3"},{"type":"function","doc":"Returns the AST of code that registers __params__ module attribute.","title":"Hologram.Page.register_params_accumulator/0","ref":"Hologram.Page.html#register_params_accumulator/0"},{"type":"macro","doc":"Defines page's route metadata functions.","title":"Hologram.Page.route/1","ref":"Hologram.Page.html#route/1"},{"type":"callback","doc":"Returns a template in the form of an anonymous function that given variable bindings returns a DOM.","title":"Hologram.Page.template/0","ref":"Hologram.Page.html#c:template/0"},{"type":"module","doc":"","title":"Hologram.Server","ref":"Hologram.Server.html"},{"type":"type","doc":"","title":"Hologram.Server.t/0","ref":"Hologram.Server.html#t:t/0"},{"type":"module","doc":"","title":"Hologram.Router","ref":"Hologram.Router.html"},{"type":"module","doc":"","title":"Hologram.Router.Helpers","ref":"Hologram.Router.Helpers.html"},{"type":"function","doc":"Retrieves the asset path, including the digest, for the specified static file within the static directory.\nIf there's no corresponding entry for the provided static file, the static file path itself will be returned.","title":"Hologram.Router.Helpers.asset_path/1","ref":"Hologram.Router.Helpers.html#asset_path/1"},{"type":"function","doc":"Returns the relative URL of a page's JavaScript bundle using the page's digest.","title":"Hologram.Router.Helpers.page_bundle_path/1","ref":"Hologram.Router.Helpers.html#page_bundle_path/1"},{"type":"function","doc":"Builds relative URL for the given page module or a tuple of a page module and params.","title":"Hologram.Router.Helpers.page_path/1","ref":"Hologram.Router.Helpers.html#page_path/1"},{"type":"function","doc":"Builds relative URL for the given page module and params.","title":"Hologram.Router.Helpers.page_path/2","ref":"Hologram.Router.Helpers.html#page_path/2"},{"type":"module","doc":"","title":"Hologram.Socket","ref":"Hologram.Socket.html"},{"type":"module","doc":"","title":"Hologram.UI.Link","ref":"Hologram.UI.Link.html"},{"type":"function","doc":"Returns true to indicate that the callee module is a component module (has \"use Hologram.Component\" directive).","title":"Hologram.UI.Link.__is_hologram_component__/0","ref":"Hologram.UI.Link.html#__is_hologram_component__/0"},{"type":"function","doc":"iex> __is_hologram_component__()\n    true","title":"Examples - Hologram.UI.Link.__is_hologram_component__/0","ref":"Hologram.UI.Link.html#__is_hologram_component__/0-examples"},{"type":"function","doc":"Returns the list of property definitions for the compiled component.","title":"Hologram.UI.Link.__props__/0","ref":"Hologram.UI.Link.html#__props__/0"},{"type":"module","doc":"","title":"Hologram.UI.Runtime","ref":"Hologram.UI.Runtime.html"},{"type":"function","doc":"Returns true to indicate that the callee module is a component module (has \"use Hologram.Component\" directive).","title":"Hologram.UI.Runtime.__is_hologram_component__/0","ref":"Hologram.UI.Runtime.html#__is_hologram_component__/0"},{"type":"function","doc":"iex> __is_hologram_component__()\n    true","title":"Examples - Hologram.UI.Runtime.__is_hologram_component__/0","ref":"Hologram.UI.Runtime.html#__is_hologram_component__/0-examples"},{"type":"function","doc":"Returns the list of property definitions for the compiled component.","title":"Hologram.UI.Runtime.__props__/0","ref":"Hologram.UI.Runtime.html#__props__/0"},{"type":"exception","doc":"Raised when an asset can't be found.","title":"Hologram.AssetNotFoundError","ref":"Hologram.AssetNotFoundError.html"},{"type":"exception","doc":"Raised when a page or a component can't be compiled.","title":"Hologram.CompileError","ref":"Hologram.CompileError.html"},{"type":"exception","doc":"Raised when a page param is invalid.","title":"Hologram.ParamError","ref":"Hologram.ParamError.html"},{"type":"exception","doc":"Raised when template markup is invalid.","title":"Hologram.TemplateSyntaxError","ref":"Hologram.TemplateSyntaxError.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}